package cn.wisenergy.chnmuseum.party.common.mvc;

public class HttpResult<T> {

    // 响应的状态码
    private Integer resultCode;

    // 响应的响应信息
    private String message;

    // 响应的响应体
    private T data;

    public HttpResult() {
    }

    public HttpResult(Integer resultCode, String message) {
        this.resultCode = resultCode;
        this.message = message;
    }

    public HttpResult(Integer resultCode, T data) {
        this.resultCode = resultCode;
        this.data = data;
    }

    public HttpResult(Integer resultCode, String message, T data) {
        this.resultCode = resultCode;
        this.message = message;
        this.data = data;
    }

    public Integer getResultCode() {
        return resultCode;
    }

    public void setResultCode(Integer resultCode) {
        this.resultCode = resultCode;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }
}
